%Code in this file generates tables using results saved from estimatenew.m
%with various sample sizes and choices of basis functions.
%
%Ben Deaner 2020 (bendeaner@gmail.com)

%%%%%%%%%%%generate table with results with quadratic and interactions%%%%
clear

meanbias=nan(6,4);
meansd=nan(6,4);
truesd=nan(6,4);
medianbias=nan(6,4);
mediansd=nan(6,4);
coverageprob=nan(6,4);

load('MCestimates_t=10_n=100_quad.mat');
load('MCstandard_errors_t=10_n=100_quad.mat');

meanbias(1:2,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(1:2,:)=nanmean(sd,3);
truesd(1:2,:)=sqrt(nanvar(est,[],3));
medianbias(1:2,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(1:2,:)=median(sd,3);
coverageprob(1:2,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);

load('MCestimates_t=10_n=300_quad.mat');
load('MCstandard_errors_t=10_n=300_quad.mat');

meanbias(3:4,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(3:4,:)=nanmean(sd,3);
truesd(3:4,:)=sqrt(nanvar(est,[],3));
medianbias(3:4,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(3:4,:)=median(sd,3);
coverageprob(3:4,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);

load('MCestimates_t=10_n=1000_quad.mat');
load('MCstandard_errors_t=10_n=1000_quad.mat');

meanbias(5:6,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(5:6,:)=nanmean(sd,3);
truesd(5:6,:)=sqrt(nanvar(est,[],3));
medianbias(5:6,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(5:6,:)=median(sd,3);
coverageprob(5:6,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);


load('MCestimates_t=10_n=10000_quad.mat');
load('MCstandard_errors_t=10_n=10000_quad.mat');

meanbias(7:8,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(7:8,:)=nanmean(sd,3);
truesd(7:8,:)=sqrt(nanvar(est,[],3));
medianbias(7:8,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(7:8,:)=median(sd,3);
coverageprob(7:8,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);


rownames={'continuation (t=10, n=100)','replacement (t=10, n=100)','continuation (t=10, n=300)','replacement (t=10, n=300)','continuation (t=10, n=1000)','replacement (t=10, n=1000)','continuation (t=10, n=10000)','replacement (t=10, n=10000)'};
columnnames={'absolute mean bias (not corrected)','absolute mean bias (corrected)','median standard error','standard deviation (not corrected)','standard deviation (corrected)','95% confidence interval coverage (not corrected)','95% confidence interval coverage (corrected)'};
T=table(meanbias(:,1),meanbias(:,4),mediansd(:,4),truesd(:,1),truesd(:,4),coverageprob(:,1),coverageprob(:,4),'VariableNames',columnnames,'RowNames',rownames);

writetable(T,'some_results_quad.csv','WriteRowNames',true);

%%%%%%%%%%%generate table with results with linear terms%%%%%%%%%
clear

meanbias=nan(6,4);
meansd=nan(6,4);
truesd=nan(6,4);
medianbias=nan(6,4);
mediansd=nan(6,4);
coverageprob=nan(6,4);

load('MCestimates_t=10_n=100.mat');
load('MCstandard_errors_t=10_n=100.mat');

meanbias(1:2,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(1:2,:)=nanmean(sd,3);
truesd(1:2,:)=sqrt(nanvar(est,[],3));
medianbias(1:2,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(1:2,:)=median(sd,3);
coverageprob(1:2,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);

load('MCestimates_t=10_n=300.mat');
load('MCstandard_errors_t=10_n=300.mat');

meanbias(3:4,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(3:4,:)=nanmean(sd,3);
truesd(3:4,:)=sqrt(nanvar(est,[],3));
medianbias(3:4,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(3:4,:)=median(sd,3);
coverageprob(3:4,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);

load('MCestimates_t=10_n=1000.mat');
load('MCstandard_errors_t=10_n=1000.mat');

meanbias(5:6,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(5:6,:)=nanmean(sd,3);
truesd(5:6,:)=sqrt(nanvar(est,[],3));
medianbias(5:6,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(5:6,:)=median(sd,3);
coverageprob(5:6,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);


load('MCestimates_t=10_n=10000.mat');
load('MCstandard_errors_t=10_n=10000.mat');

meanbias(7:8,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(7:8,:)=nanmean(sd,3);
truesd(7:8,:)=sqrt(nanvar(est,[],3));
medianbias(7:8,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(7:8,:)=median(sd,3);
coverageprob(7:8,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);


rownames={'continuation (t=10, n=100)','replacement (t=10, n=100)','continuation (t=10, n=300)','replacement (t=10, n=300)','continuation (t=10, n=1000)','replacement (t=10, n=1000)','continuation (t=10, n=10000)','replacement (t=10, n=10000)'};
columnnames={'absolute mean bias (not corrected)','absolute mean bias (corrected)','median standard error','standard deviation (not corrected)','standard deviation (corrected)','95% confidence interval coverage (not corrected)','95% confidence interval coverage (corrected)'};
T=table(meanbias(:,1),meanbias(:,4),mediansd(:,4),truesd(:,1),truesd(:,4),coverageprob(:,1),coverageprob(:,4),'VariableNames',columnnames,'RowNames',rownames);

writetable(T,'some_results.csv','WriteRowNames',true);

%%%%%%%%%%%generate table with results with linear and squared terms%%%%%%%%%
clear

meanbias=nan(6,4);
meansd=nan(6,4);
truesd=nan(6,4);
medianbias=nan(6,4);
mediansd=nan(6,4);
coverageprob=nan(6,4);

load('MCestimates_t=10_n=100_squares.mat');
load('MCstandard_errors_t=10_n=100_squares.mat');

meanbias(1:2,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(1:2,:)=nanmean(sd,3);
truesd(1:2,:)=sqrt(nanvar(est,[],3));
medianbias(1:2,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(1:2,:)=median(sd,3);
coverageprob(1:2,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);

load('MCestimates_t=10_n=300_squares.mat');
load('MCstandard_errors_t=10_n=300_squares.mat');

meanbias(3:4,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(3:4,:)=nanmean(sd,3);
truesd(3:4,:)=sqrt(nanvar(est,[],3));
medianbias(3:4,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(3:4,:)=median(sd,3);
coverageprob(3:4,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);

load('MCestimates_t=10_n=1000_squares.mat');
load('MCstandard_errors_t=10_n=1000_squares.mat');

meanbias(5:6,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(5:6,:)=nanmean(sd,3);
truesd(5:6,:)=sqrt(nanvar(est,[],3));
medianbias(5:6,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(5:6,:)=median(sd,3);
coverageprob(5:6,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);


load('MCestimates_t=10_n=10000_squares.mat');
load('MCstandard_errors_t=10_n=10000_squares.mat');

meanbias(7:8,:)=abs(nanmean(est,3)-[-0.5;-1]);
meansd(7:8,:)=nanmean(sd,3);
truesd(7:8,:)=sqrt(nanvar(est,[],3));
medianbias(7:8,:)=abs(median(est,3)-[-0.5;-1]);
mediansd(7:8,:)=median(sd,3);
coverageprob(7:8,:)=nanmean((abs(est-[-0.5;-1])./sd)<=1.96,3);


rownames={'continuation (t=10, n=100)','replacement (t=10, n=100)','continuation (t=10, n=300)','replacement (t=10, n=300)','continuation (t=10, n=1000)','replacement (t=10, n=1000)','continuation (t=10, n=10000)','replacement (t=10, n=10000)'};
columnnames={'absolute mean bias (not corrected)','absolute mean bias (corrected)','median standard error','standard deviation (not corrected)','standard deviation (corrected)','95% confidence interval coverage (not corrected)','95% confidence interval coverage (corrected)'};
T=table(meanbias(:,1),meanbias(:,4),mediansd(:,4),truesd(:,1),truesd(:,4),coverageprob(:,1),coverageprob(:,4),'VariableNames',columnnames,'RowNames',rownames);

writetable(T,'some_results_squares.csv','WriteRowNames',true);

